unit frm_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, IBODataset, IB_Components, StdCtrls, DBCtrls, Mask, ExtCtrls;

type
  TForm4 = class(TForm)
    Cnn: TIB_Connection;
    tr_RO: TIB_Transaction;
    tr_Update: TIB_Transaction;
    qry: TIBOQuery;
    qryWithBlob: TIBOQuery;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    ds: TDataSource;
    dsWithBlob: TDataSource;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    DBMemo1: TDBMemo;
    CheckBox1: TCheckBox;
    procedure CheckBox1Click(Sender: TObject);
    procedure CnnAfterConnect(Sender: TIB_Connection);
    procedure FormCreate(Sender: TObject);
  private
    FUsingTransForUpdate: Boolean;
    procedure SetUsingTransForUpdate(const Value: Boolean);
  public
    property UsingTransForUpdate: Boolean read FUsingTransForUpdate write
        SetUsingTransForUpdate default True;
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.CheckBox1Click(Sender: TObject);
begin
  UsingTransForUpdate := CheckBox1.Checked;
end;

procedure TForm4.CnnAfterConnect(Sender: TIB_Connection);
begin
  qry.Open;
  qryWithBlob.Open;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  FUsingTransForUpdate := True;
  TIB_Session.DefaultSession.UseCursor := False;
  Cnn.Path := ExtractFilePath(Application.ExeName) + 'support.fdb';
  Cnn.Connect;
end;

procedure TForm4.SetUsingTransForUpdate(const Value: Boolean);
begin
  if FUsingTransForUpdate <> Value then
  begin
    FUsingTransForUpdate := Value;
    if Cnn.Connected then
      Cnn.Disconnect;
    if FUsingTransForUpdate then
    begin
      qry.IB_Transaction := tr_RO;
      qryWithBlob.IB_Transaction := tr_RO;
      qry.IB_TransForUpdates := tr_Update;
      qryWithBlob.IB_TransForUpdates := tr_Update;
    end
    else
    begin
      qry.IB_Transaction := tr_Update;
      qryWithBlob.IB_Transaction := tr_Update;
      qry.IB_TransForUpdates := nil;
      qryWithBlob.IB_TransForUpdates := nil;
    end;
    Cnn.Connect;
  end;
end;

end.
